package com.simianlogic
{
   import flash.events.Event;
   import flash.filters.DropShadowFilter;
   import flash.filters.GlowFilter;
   import flash.utils.getTimer;
   import org.cove.ape.CircleParticle;
   import org.cove.ape.Vector;
   
   public class constantVSprite extends CircleParticle
   {
       
      
      public var myColor:uint = 10027008;
      
      public var birth:int = 0;
      
      public var dirty:Boolean = true;
      
      public var lastPosition:Vector;
      
      public var VELOCITY:Number;
      
      public function constantVSprite(param1:Number, param2:Number)
      {
         VELOCITY = Math.sqrt(18);
         dirty = true;
         birth = 0;
         myColor = 10027008;
         super(param1,param2,10,false,1,0.7);
         lastPosition = new Vector(param1,param2);
         birth = getTimer();
         paint();
      }
      
      override public function update(param1:Number) : void
      {
         var _loc2_:Number = NaN;
         var _loc3_:Vector = null;
         lastPosition = new Vector(position.x,position.y);
         _loc2_ = velocity.magnitude();
         super.update(param1);
         _loc3_ = velocity.normalize();
         velocity = _loc3_.mult(VELOCITY);
         if(Math.abs(velocity.magnitude() - _loc2_) > 0.1)
         {
            sprite.dispatchEvent(new Event("sound_bounce_soft",true));
         }
      }
      
      override public function paint() : void
      {
         var _loc1_:GlowFilter = null;
         var _loc2_:DropShadowFilter = null;
         super.paint();
         if(dirty)
         {
            _loc1_ = new GlowFilter(0,1.1,5,5);
            _loc2_ = new DropShadowFilter(7,45,0,0.6,4,4,1,1,true);
            sprite.filters = [_loc2_,_loc1_];
            sprite.graphics.clear();
            sprite.graphics.lineStyle(1,0,1);
            sprite.graphics.beginFill(16777215,1);
            sprite.graphics.drawCircle(0,0,radius);
            sprite.graphics.endFill();
            dirty = false;
         }
      }
      
      public function setVelocity(param1:Vector) : void
      {
         velocity = param1;
         VELOCITY = param1.magnitude();
      }
   }
}
